#!/usr/bin/env python

import cherrypy, os, string

class Main(object):
    def __init__(self):
        self.outputConfigMap()
    def index(self):
        page = "CRAB config file home page"
        page+= "<ul>"
        for f in os.listdir('files'):
            page+="""<li><a href="files/%s">%s</a></li>"""%(f,f)
        page+= "</ul>"
        return page
    index.exposed=True
    def outputConfigMap(self):
        """Log server configuration parameters"""
        serverVars = [
                      'httpservers',
                      'instance',
                      'interrupt',
                      'max_request_body_size',
                      'max_request_header_size',
                      'protocol_version',
                      'ssl_certificate',
                      'ssl_private_key',
                      'socket_host',
                      'socket_port',
                      'socket_file',
                      'reverse_dns',
                      'socket_queue_size',
                      'thread_pool',
                     ]
        msg="+++ CherryPy serer configuration:"
        print msg
        for var in serverVars:
            msg="    %s: %s" % (var, getattr(cherrypy.server,var))
            print msg

if __name__ == '__main__':

   cherrypy.config.update({'server.socket_port': 8102,
                           'server.thread_pool': 20,
                           'environment': 'production',
                           'log.screen':True,
                           'log.error_file':"crab.log",
                          })
   conf={'/': {'tools.staticdir.root': os.getcwd(),
               'tools.staticdir.on':True,
               'tools.staticdir.dir':'files',
               'tools.staticdir.content_types':{'conf':'text/plain'},
              },
         '/files':{'tools.staticdir.on':True,
                   'tools.staticdir.dir':'files',
                   'tools.staticdir.content_types':{'conf':'text/plain'},
                   },
        }
   cherrypy.quickstart(Main(), '/', config=conf)
